Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/FindReplace/fr_engine.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/FindReplace/fr_engine.js	(revision 2968)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/FindReplace/fr_engine.js	(working copy)
@@ -5,144 +5,150 @@
  e-mail: caugb@ibest.com.br
 \*---------------------------------------*/
 
-var FindReplace = window.opener.FindReplace;
-var i18n = FindReplace.I18N;
-var editor = FindReplace.editor;
-var is_mo = window.opener.HTMLArea.is_gecko;
-var tosearch = '';
-var pater = null;
-var buffer = null;
-var matches = 0;
-var replaces = 0;
-var fr_spans = new Array();
-
-function execSearch(params) {
-var ihtml = editor._doc.body.innerHTML;
-  if(buffer == null) 
-    buffer = ihtml;
-    
-  if(params['fr_pattern'] != tosearch) {
-    if(tosearch != '')
-      clearDoc();
-  tosearch = params['fr_pattern'];
-  }
-  
-  if(matches == 0) {
-  er = params['fr_words'] ? "/(?!<[^>]*)(\\b"+params['fr_pattern']+"\\b)(?![^<]*>)/g" :
-                            "/(?!<[^>]*)("+params['fr_pattern']+")(?![^<]*>)/g";
-    if(!params['fr_matchcase'])
-      er += "i"; 
-
-  pater = eval(er);
-  
-  var tago = '<span id=frmark>';
-  var tagc = '</span>';
-  var newHtml = ihtml.replace(pater,tago+"$1"+tagc);
-  
-  editor.setHTML(newHtml);
-  
-  var getallspans = editor._doc.body.getElementsByTagName("span"); 
-    for (var i = 0; i < getallspans.length; i++) 
-      if(/^frmark/.test(getallspans[i].id))
-        fr_spans.push(getallspans[i]);
-  }
-
-spanWalker(params['fr_pattern'],params['fr_replacement'],params['fr_replaceall']);
-};
-
-function spanWalker(pattern,replacement,replaceall) {
-var foundtrue = false;
-clearMarks();
-
-  for (var i = matches; i < fr_spans.length; i++) {
-  var elm = fr_spans[i];
-  foundtrue = true;
-    if(!(/[0-9]$/.test(elm.id))) { 
-    matches++;
-    disab('fr_clear',false);
-    elm.id = 'frmark_'+matches;
-    elm.style.color = 'white';
-    elm.style.backgroundColor = 'highlight';
-    elm.style.fontWeight = 'bold';
-    elm.scrollIntoView(false);
-      //if(  /\w/.test(replacement)  ) {
-        if(replaceall || confirm(i18n["Substitute this occurrence?"])) {
-        elm.firstChild.replaceData(0,elm.firstChild.data.length,replacement);
-        replaces++;
-        disab('fr_undo',false);
-        }
-        if(replaceall) {
-        clearMarks();
-        continue;
-        }
-      //}
-    break;
-    }
-  }
-  var last = (i >= fr_spans.length - 1);
-  if(last || !foundtrue) { // EOF
-  var message = i18n["Done"]+':\n\n';
-    if(matches > 0) {
-      if(matches == 1) message += matches+' '+i18n["found item"];
-      else             message += matches+' '+i18n["found items"];
-      if(replaces > 0) {
-        if(replaces == 1) message += ',\n'+replaces+' '+i18n["replaced item"];
-        else              message += ',\n'+replaces+' '+i18n["replaced items"];
-      }
-    hiliteAll();
-    disab('fr_hiliteall',false);
-    } else { message += '"'+pattern+'" '+i18n["not found"]; }
-  alert(message+'.');
-  }
-};
-
-function clearDoc() {
-var doc = editor._doc.body.innerHTML; 
-var er = /(<span\s+[^>]*id=.?frmark[^>]*>)([^<>]*)(<\/span>)/gi;
-editor._doc.body.innerHTML = doc.replace(er,"$2");
-pater = null;
-tosearch = '';
-fr_spans = new Array();
-matches = 0;
-replaces = 0;
-disab("fr_hiliteall,fr_clear",true);
-};
-
-function clearMarks() { 
-var getall = editor._doc.body.getElementsByTagName("span"); 
-  for (var i = 0; i < getall.length; i++) {
-  var elm = getall[i];
-    if(/^frmark/.test(elm.id)) {
-    var objStyle = editor._doc.getElementById(elm.id).style;
-    objStyle.backgroundColor = "";
-    objStyle.color = "";
-    objStyle.fontWeight = "";
-    }
-  }
-};
-
-function hiliteAll() { 
-var getall = editor._doc.body.getElementsByTagName("span"); 
-  for (var i = 0; i < getall.length; i++) {
-  var elm = getall[i];
-    if(/^frmark/.test(elm.id)) { 
-    var objStyle = editor._doc.getElementById(elm.id).style;
-    objStyle.backgroundColor = "highlight";
-    objStyle.color = "white";
-    objStyle.fontWeight = "bold";
-    }
-  }
-};
-
-function resetContents() { 
-  if(buffer == null) return;
-var transp = editor._doc.body.innerHTML;
-editor._doc.body.innerHTML = buffer;
-buffer = transp;
-};
-
-function disab(elms,toset) { 
-var names = elms.split(/[,; ]+/);
-  for(var i = 0; i < names.length; i++) 
-    document.getElementById(names[i]).disabled = toset;
-};
+	var tosearch = '';
+	var pater = null;
+	var buffer = null;
+	var matches = 0;
+	var replaces = 0;
+	var fr_spans = new Array();
+		
+	function execSearch (params) {
+		var ihtml = editor._doc.body.innerHTML;
+		if (buffer == null) {
+			buffer = ihtml;
+		}
+		
+		if (params.fr_pattern != tosearch) {
+			if (tosearch != "") {
+				clearDoc();
+			}
+			tosearch = params.fr_pattern;
+		}
+		
+		if (matches == 0) {
+			er = params.fr_words ? "/(?!<[^>]*)(\\b"+params.fr_pattern+"\\b)(?![^<]*>)/g" : "/(?!<[^>]*)("+params.fr_pattern+")(?![^<]*>)/g";
+			if (!params.fr_matchcase) {
+				er += "i";
+			}
+			
+			pater = eval(er);
+			
+			var tago = '<span id=frmark>';
+			var tagc = '</span>';
+			var newHtml = ihtml.replace(pater,tago+"$1"+tagc);
+			editor.setHTML(newHtml);
+			
+			var getallspans = editor._doc.body.getElementsByTagName("span"); 
+			for (var i = 0; i < getallspans.length; i++) {
+				if (/^frmark/.test(getallspans[i].id)) {
+					fr_spans.push(getallspans[i]);
+				}
+			}
+		}
+		spanWalker(params['fr_pattern'],params['fr_replacement'],params['fr_replaceall']);
+	};
+	
+	function spanWalker (pattern,replacement,replaceall) {
+		var foundtrue = false;
+		clearMarks();
+		
+		for (var i = matches; i < fr_spans.length; i++) {
+			var elm = fr_spans[i];
+			foundtrue = true;
+			if (!(/[0-9]$/.test(elm.id))) { 
+				matches++;
+				disable('fr_clear', false);
+				elm.id = 'frmark_'+ matches;
+				elm.style.color = 'white';
+				elm.style.backgroundColor = 'highlight';
+				elm.style.fontWeight = 'bold';
+				elm.scrollIntoView(false);
+				if (replaceall || confirm(dialog.plugin.localize("Substitute this occurrence?"))) {
+					elm.firstChild.replaceData(0,elm.firstChild.data.length,replacement);
+					replaces++;
+					disable('fr_undo', false);
+				}
+				if (replaceall) {
+					clearMarks();
+					continue;
+				}
+				break;
+			}
+		}
+		var last = (i >= fr_spans.length - 1);
+		if (last || !foundtrue) { // EOF
+			var message = dialog.plugin.localize("Done")+":\n\n";
+			if (matches > 0) {
+				if (matches == 1) {
+					message += matches+' ' + dialog.plugin.localize("found item");
+				} else {
+					message += matches+' ' + dialog.plugin.localize("found items");
+				}
+				if (replaces > 0) {
+					if (replaces == 1) {
+						message += ',\n'+replaces+' ' + dialog.plugin.localize("replaced item");
+					} else {
+						message += ',\n'+replaces+' ' + dialog.plugin.localize("replaced items");
+					}
+				}
+				hiliteAll();
+				disable('fr_hiliteall', false);
+			} else {
+				message += '"' + pattern + '" ' + dialog.plugin.localize("not found");
+			}
+			alert(message+'.');
+		}
+	};
+	
+	function clearDoc () {
+		var doc = editor._doc.body.innerHTML; 
+		var er = /(<span\s+[^>]*id=.?frmark[^>]*>)([^<>]*)(<\/span>)/gi;
+		editor._doc.body.innerHTML = doc.replace(er,"$2");
+		pater = null;
+		tosearch = '';
+		fr_spans = new Array();
+		matches = 0;
+		replaces = 0;
+		disable("fr_hiliteall,fr_clear", true);
+	};
+	
+	function clearMarks () {
+		var getall = editor._doc.body.getElementsByTagName("span"); 
+		for (var i = 0; i < getall.length; i++) {
+			var elm = getall[i];
+			if (/^frmark/.test(elm.id)) {
+				var objStyle = editor._doc.getElementById(elm.id).style;
+				objStyle.backgroundColor = "";
+				objStyle.color = "";
+				objStyle.fontWeight = "";
+			}
+		}
+	};
+	
+	function hiliteAll () {
+		var getall = editor._doc.body.getElementsByTagName("span"); 
+		for (var i = 0; i < getall.length; i++) {
+			var elm = getall[i];
+			if (/^frmark/.test(elm.id)) {
+				var objStyle = editor._doc.getElementById(elm.id).style;
+				objStyle.backgroundColor = "highlight";
+				objStyle.color = "white";
+				objStyle.fontWeight = "bold";
+			}
+		}
+	};
+	
+	function resetContents () {
+		if (buffer == null) return;
+		var transp = editor._doc.body.innerHTML;
+		editor._doc.body.innerHTML = buffer;
+		buffer = transp;
+	};
+	
+	function disable (elms, toset) {
+		var names = elms.split(/[,; ]+/);
+		for (var i = 0; i < names.length; i++) {
+			document.getElementById(names[i]).disabled = toset;
+		}
+	};
+	
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/InsertSmiley/insert-smiley.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/InsertSmiley/insert-smiley.js	(revision 2968)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/InsertSmiley/insert-smiley.js	(working copy)
@@ -2,7 +2,7 @@
 *  Copyright notice
 *
 *  (c) 2004  Ki Master George <kimastergeorge@gmail.com>
-*  (c) 2005, 2006 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
+*  (c) 2005-2008 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -33,52 +33,79 @@
  * TYPO3 CVS ID: $Id$
  */
 
-var HTMLAreaeditor;
-
-InsertSmiley = function(editor) {
-	this.editor = editor;
-	var cfg = editor.config;
-	var actionHandlerFunctRef = InsertSmiley.actionHandler(this);
-	cfg.registerButton("InsertSmiley", InsertSmiley_langArray["Insert Smiley"],  editor.imgURL("ed_smiley.gif", "InsertSmiley"), false, actionHandlerFunctRef);
-};
-
-InsertSmiley.I18N = InsertSmiley_langArray;
-
-InsertSmiley.actionHandler = function(instance) {
-	return (function(editor) {
-		instance.buttonPress(editor);
-	});
-};
-
-InsertSmiley.prototype.buttonPress = function(editor) { 
-	var sel = editor.getSelectedHTML().replace(/(<[^>]*>|&nbsp;|\n|\r)/g,""); 
-	var param = new Object();
-	param.editor = editor;
-	param.editor_url = _typo3_host_url + _editor_url;
-	if(param.editor_url == "../") {
-		param.editor_url = document.URL;
-		param.editor_url = param.editor_url.replace(/^(.*\/).*\/.*$/g, "$1");
+InsertSmiley = HTMLArea.Plugin.extend({
+		
+	constructor : function(editor, pluginName) {
+		this.base(editor, pluginName);
+	},
+	
+	/*
+	 * This function gets called by the class constructor
+	 */
+	configurePlugin : function(editor) {
+		
+		/*
+		 * Registering plugin "About" information
+		 */
+		var pluginInformation = {
+			version		: "1.2",
+			developer	: "Ki Master George & Stanislas Rolland",
+			developerUrl	: "http://www.fructifor.ca/",
+			copyrightOwner	: "Ki Master George & Stanislas Rolland",
+			sponsor		: "Ki Master George & Fructifor Inc.",
+			sponsorUrl	: "http://www.fructifor.ca/",
+			license		: "GPL"
+		};
+		this.registerPluginInformation(pluginInformation);
+		
+		/*
+		 * Registering the button
+		 */
+		var buttonId = "InsertSmiley";
+		var buttonConfiguration = {
+			id		: buttonId,
+			tooltip		: this.localize("Insert Smiley"),
+			action		: "onButtonPress",
+			dialog		: true
+		};
+		this.registerButton(buttonConfiguration);
+		
+		return true;
+	},
+	
+	/*
+	 * This function gets called when the button was pressed.
+	 *
+	 * @param	object		editor: the editor instance
+	 * @param	string		id: the button id or the key
+	 *
+	 * @return	boolean		false if action is completed
+	 */
+	onButtonPress : function (editor, id) {
+		
+		var sel = this.editor.getSelectedHTML().replace(/(<[^>]*>|&nbsp;|\n|\r)/g,"");
+		var param = new Object();
+		param.editor_url = _typo3_host_url + _editor_url;
+		if (param.editor_url == "../") {
+			param.editor_url = document.URL;
+			param.editor_url = param.editor_url.replace(/^(.*\/).*\/.*$/g, "$1");
+		}
+		this.dialog = this.openDialog("InsertSmiley", this.makeUrlFromPopupName("insertsmiley"), "insertImageTag", param, {width:250, height:220});
+	},
+	
+	/*
+	 * Insert the selected smiley
+	 *
+	 * @param	object		param: the selected smiley
+	 *
+	 * @return	boolean		false
+	 */
+	insertImageTag : function (param) {
+		if (param && typeof(param.imgURL) != "undefined") {
+			this.editor.focusEditor();
+			this.editor.insertHTML('<img src="' + param.imgURL + '" alt="Smiley" />');
+		}
+		return false;
 	}
-	var setTagHandlerFunctRef = InsertSmiley.setTagHandler(this);
-  	editor._popupDialog("plugin://InsertSmiley/insertsmiley", setTagHandlerFunctRef, param, 250, 220);
-};
+});
 
-InsertSmiley.setTagHandler = function(instance) {
-	return (function(param) {
-		if(param && typeof(param.imgURL) != "undefined") {
-			instance.editor.focusEditor();
-			instance.editor.insertHTML("<img src=\"" + param.imgURL + "\" alt=\"Smiley\" />");
-		}
-	});
-};
-
-InsertSmiley._pluginInfo = {
-	name          : "InsertSmiley",
-	version       : "1.1",
-	developer     : "Ki Master George & Stanislas Rolland",
-	developer_url : "http://www.fructifor.ca/",
-	c_owner       : "Ki Master George & Stanislas Rolland",
-	sponsor       : "Ki Master George & Fructifor Inc.",
-	sponsor_url   : "http://www.fructifor.ca/",
-	license       : "GPL"
-};
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/RemoveFormat/remove-format.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/RemoveFormat/remove-format.js	(revision 2968)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/RemoveFormat/remove-format.js	(working copy)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2005, 2006 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
+*  (c) 2005-2008 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -29,64 +29,89 @@
  *
  * TYPO3 CVS ID: $Id$
  */
-
-RemoveFormat = function(editor) {
-	this.editor = editor;
-	var cfg = editor.config;
-	var actionHandlerFunctRef = RemoveFormat.actionHandler(this);
-	cfg.registerButton({
-		id		: "RemoveFormat",
-		tooltip		: RemoveFormat_langArray["RemoveFormatTooltip"],
-		image		: editor.imgURL("ed_clean.gif", "RemoveFormat"),
-		textMode	: false,
-		action		: actionHandlerFunctRef
-	});
+RemoveFormat = HTMLArea.Plugin.extend({
+		
+	constructor : function(editor, pluginName) {
+		this.base(editor, pluginName);
+	},
 	
-	this.popupWidth = 285;
-	this.popupHeight = 255;
-};
-
-RemoveFormat.I18N = RemoveFormat_langArray;
-
-RemoveFormat._pluginInfo = {
-	name          : "RemoveFormat",
-	version       : "1.5",
-	developer     : "Stanislas Rolland",
-	developer_url : "http://www.fructifor.ca/",
-	sponsor       : "Fructifor Inc.",
-	sponsor_url   : "http://www.fructifor.ca/",
-	license       : "GPL"
-};
-
-RemoveFormat.actionHandler = function(instance) {
-	return (function(editor) {
-		instance.buttonPress(editor);
-	});
-};
-
-RemoveFormat.prototype.buttonPress = function(editor){
-	var applyRequestFunctRef = RemoveFormat.applyRequest(this, editor);
-	editor._popupDialog("plugin://RemoveFormat/removeformat", applyRequestFunctRef, editor, this.popupWidth, this.popupHeight);
-};
-
-RemoveFormat.applyRequest = function(instance,editor){
-	return(function(param) {
+	/*
+	 * This function gets called by the class constructor
+	 */
+	configurePlugin : function(editor) {
+		
+		/*
+		 * Registering plugin "About" information
+		 */
+		var pluginInformation = {
+			version		: "1.6",
+			developer	: "Stanislas Rolland",
+			developerUrl	: "http://www.fructifor.ca/",
+			copyrightOwner	: "Stanislas Rolland",
+			sponsor		: "Fructifor Inc.",
+			sponsorUrl	: "http://www.fructifor.ca/",
+			license		: "GPL"
+		};
+		this.registerPluginInformation(pluginInformation);
+		
+		/*
+		 * Registering the button
+		 */
+		var buttonId = "RemoveFormat";
+		var buttonConfiguration = {
+			id		: buttonId,
+			tooltip		: this.localize(buttonId+"Tooltip"),
+			action		: "onButtonPress",
+			dialog		: true
+		};
+		this.registerButton(buttonConfiguration);
+		
+		this.popupWidth = 300;
+		this.popupHeight = 280;
+		
+		return true;
+	},
+	
+	/*
+	 * This function gets called when the button was pressed.
+	 *
+	 * @param	object		editor: the editor instance
+	 * @param	string		id: the button id or the key
+	 *
+	 * @return	boolean		false if action is completed
+	 */
+	onButtonPress : function (editor, id, target) {
+			// Could be a button or its hotkey
+		var buttonId = this.translateHotKey(id);
+		buttonId = buttonId ? buttonId : id;
+		
+		this.dialog = this.openDialog("RemoveFormat", this.makeUrlFromPopupName("removeformat"), "applyRequest", null, {width:this.popupWidth, height:this.popupHeight});
+		return false;
+	},
+	
+	/*
+	 * Perform the cleaning request
+	 * .
+	 */
+	applyRequest : function(param) {
+		
+		var editor = this.editor;
 		editor.focusEditor();
-
+		
 		if (param) {
-
+			
 			if (param["cleaning_area"] == "all") {
 				var html = editor._doc.body.innerHTML;
 			} else {
 				var html = editor.getSelectedHTML();
  			}
-
-			if(html) {
-
+			
+			if (html) {
+				
 				if (param["html_all"]== true) {
 					html = html.replace(/<[\!]*?[^<>]*?>/g, "");
 				}
- 
+				
 				if (param["formatting"] == true) {
 						// remove font, b, strong, i, em, u, strike, span and other tags
 					var regF1 = new RegExp("<\/?(abbr|acronym|b[^a-zA-Z]|big|cite|code|em[^a-zA-Z]|font|i[^a-zA-Z]|q|s[^a-zA-Z]|samp|small|span|strike|strong|sub|sup|u[^a-zA-Z]|var)[^>]*>", "gi"); 
@@ -96,12 +121,12 @@
 					var regF3 = new RegExp(" (class|align|cellpadding|cellspacing|frame|bgcolor)=(([^>\s\"]+)|(\"[^>\"]*\"))", "gi");
 					html = html.replace(regF2, "").replace(regF3, "");
 				}
-
+				
 				if (param["images"] == true) {
 						// remove any IMG tag
 					html = html.replace(/<\/?img[^>]*>/gi, ""); //remove img tags								
 				}
-
+				
 				if (param["ms_formatting"] == true) {
 						// make one line
 					var regMS1 = new RegExp("(\r\n|\n|\r)", "g"); 
@@ -140,7 +165,7 @@
 						html = html.replace(reg10, " ");
 					}
 				}
-
+				
 				if (param["cleaning_area"] == "all") { 				 		
 					editor._doc.body.innerHTML = html;
 				} else { 
@@ -150,5 +175,6 @@
 		} else {
 			return false;
 		}
-	});
-};
+	}
+});
+
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/SpellChecker/spell-check-ui.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/SpellChecker/spell-check-ui.js	(revision 2968)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/SpellChecker/spell-check-ui.js	(working copy)
@@ -2,7 +2,7 @@
 *  Copyright notice
 *
 *  (c) 2003 dynarch.com. Authored by Mihai Bazon, sponsored by www.americanbible.org.
-*  (c) 2004, 2005, 2006 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
+*  (c) 2004-2008 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -32,17 +32,6 @@
  *
  * TYPO3 CVS ID: $Id$
  */
-
-// internationalization file was already loaded in parent ;-)
-var SpellChecker = window.opener.SpellChecker;
-var i18n = SpellChecker.I18N;
-
-// initial_dictonary, charset and pspell_mode added by Stanislas Rolland 2004-09-16
-var initial_dictionary = SpellChecker.f_dictionary;
-var pspell_charset = SpellChecker.f_charset;
-var pspell_mode = SpellChecker.f_pspell_mode;
-
-var editor = SpellChecker.editor;
 var frame = null;
 var currentElement = null;
 var wrongWords = null;
@@ -65,11 +54,11 @@
 		} else
 			el.className = "HA-spellcheck-fixed";
 	}
-	return window.opener.HTMLArea.getHTML(frame.contentWindow.document.body, false, editor);
+	return window.opener.HTMLArea.getHTML(frame.contentWindow.document.body, false, dialog.plugin.editor);
 };
 
 function recheckClicked() {
-	document.getElementById("status").innerHTML = i18n["Please wait: changing dictionary to"] + ': "' + document.getElementById("f_dictionary").value + '".';
+	document.getElementById("status").innerHTML = dialog.plugin.localize("Please wait: changing dictionary to") + ': "' + document.getElementById("f_dictionary").value + '".';
 	var field = document.getElementById("f_content");
 	field.value = makeCleanDoc(true);
 	field.form.submit();
@@ -77,9 +66,9 @@
 
 function saveClicked() {
 	if (modified) {
-		editor.setHTML(makeCleanDoc(false));
+		dialog.plugin.editor.setHTML(makeCleanDoc(false));
 	}
-	if ((to_p_dict.length || to_r_list.length) && SpellChecker.enablePersonalDicts) {
+	if ((to_p_dict.length || to_r_list.length) && dialog.plugin.enablePersonalDicts) {
 		var data = {};
 		for (var i = 0;i < to_p_dict.length;i++) {
 			data['to_p_dict[' + i + ']'] = to_p_dict[i];
@@ -89,11 +78,11 @@
 			data['to_r_list[' + i + '][1]'] = to_r_list[i][1];
 		}
 		data['cmd'] = 'learn';
-		data['enablePersonalDicts'] = SpellChecker.enablePersonalDicts;
-		data['userUid'] = SpellChecker.userUid;
-		data['dictionary'] = SpellChecker.f_dictionary;
-		data['pspell_charset'] = SpellChecker.f_charset;
-		data['pspell_mode'] = SpellChecker.f_pspell_mode;
+		data['enablePersonalDicts'] = dialog.plugin.enablePersonalDicts;
+		data['userUid'] = dialog.plugin.userUid;
+		data['dictionary'] = dialog.plugin.contentISOLanguage;
+		data['pspell_charset'] = dialog.plugin.contentCharset;
+		data['pspell_mode'] = dialog.plugin.spellCheckerMode;
 		window.opener.HTMLArea._postback('plugins/SpellChecker/spell-check-logic.php', data);
 	}
 	window.close();
@@ -103,10 +92,10 @@
 function cancelClicked() {
 	var ok = true;
 	if (modified) {
-		ok = confirm(i18n["QUIT_CONFIRMATION"]);
+		ok = confirm(dialog.plugin.localize("QUIT_CONFIRMATION"));
 	}
 	if (ok) {
-		window.close();
+		dialog.close();
 	}
 	return false;
 };
@@ -135,10 +124,10 @@
 	do { 
 		++index;
 		if (index == wrongWords.length) index = 0;
-	}while((index != start) && wrongWords[index].__msh_fixed);
+	} while((index != start) && wrongWords[index].__msh_fixed);
 	if (index == start) {
 		index = 0;
-		alert(i18n["Finished list of mispelled words"]);
+		alert(dialog.plugin.localize("Finished list of mispelled words"));
 	}
 	wrongWords[index].__msh_wordClicked(true);
 	return false;
@@ -199,33 +188,31 @@
 };
 
 function initDocument() {
-	__dlg_translate(i18n);
-	__dlg_init();
-	var param = window.dialogArguments;
-	editor = param['editor'];
-	HTMLArea = param['HTMLArea'];
+	dialog.initialize();
+	var plugin = dialog.plugin;
+	var editor = plugin.editor;
+	
 	modified = false;
-	document.title = i18n["Spell Checker"];
+	document.title = dialog.plugin.localize("Spell Checker");
 	frame = document.getElementById("i_framecontent");
 	var field = document.getElementById("f_content");
 	field.value = HTMLArea.getHTML(editor._doc.body, false, editor);
 	document.getElementById("f_init").value = "0";
-	document.getElementById("f_dictionary").value = initial_dictionary;
-	document.getElementById("f_charset").value = pspell_charset;
-	document.getElementById("f_pspell_mode").value = pspell_mode;
-	document.getElementById("f_user_uid").value = SpellChecker.userUid;
-	document.getElementById("f_personal_dicts").value = SpellChecker.enablePersonalDicts;
+	document.getElementById("f_dictionary").value = plugin.contentISOLanguage;
+	document.getElementById("f_charset").value = plugin.contentCharset;
+	document.getElementById("f_pspell_mode").value = plugin.spellCheckerMode;
+	document.getElementById("f_user_uid").value = plugin.userUid;
+	document.getElementById("f_personal_dicts").value = plugin.enablePersonalDicts;
 	field.form.submit();
-
 		// assign some global event handlers
 	var select = document.getElementById("v_suggestions");
 	select.onchange = function() {
 		document.getElementById("v_replacement").value = this.value;
 	};
 	HTMLArea._addEvent(select, "dblclick", replaceClicked);
-
+	
 	document.getElementById("b_replace").onclick = replaceClicked;
-	if (SpellChecker.enablePersonalDicts) document.getElementById("b_learn").onclick = learnClicked;
+	if (plugin.enablePersonalDicts) document.getElementById("b_learn").onclick = learnClicked;
 		else document.getElementById("b_learn").style.display = 'none';
 	document.getElementById("b_replall").onclick = replaceAllClicked;
 	document.getElementById("b_ignore").onclick = ignoreClicked;
@@ -233,10 +220,10 @@
 	document.getElementById("b_recheck").onclick = recheckClicked;
 	document.getElementById("b_revert").onclick = revertClicked;
 	document.getElementById("b_info").onclick = displayInfo;
-
+	
 	document.getElementById("b_ok").onclick = saveClicked;
 	document.getElementById("b_cancel").onclick = cancelClicked;
-
+	
 	select = document.getElementById("v_dictionaries");
 	select.onchange = function() {
 		document.getElementById("f_dictionary").value = this.value;
@@ -291,20 +278,20 @@
 	var txt;
 	var txt2;
 	if (a.length == 1) {
-		txt = i18n["One occurrence"];
-		txt2 = i18n["was found."];
+		txt = dialog.plugin.localize("One occurrence");
+		txt2 = dialog.plugin.localize("was found.");
 	} else if (a.length == 2) {
-		txt = i18n["Two occurrences"];
-		txt2 = i18n["were found."];
+		txt = dialog.plugin.localize("Two occurrences");
+		txt2 = dialog.plugin.localize("were found.");
 	} else {
-		txt = a.length + " " + i18n["occurrences"];
-		txt2 = i18n["were found."];
+		txt = a.length + " " + dialog.plugin.localize("occurrences");
+		txt2 = dialog.plugin.localize("were found.");
 	}
 	var suggestions = suggested_words[this.__msh_origWord];
 	if (suggestions) suggestions = suggestions.split(/,/);
 		else suggestions = [];
 	var select = document.getElementById("v_suggestions");
-	document.getElementById("statusbar").innerHTML = txt + " " + i18n["of the word"] +
+	document.getElementById("statusbar").innerHTML = txt + " " + dialog.plugin.localize("of the word") +
 		' "<b>' + currentElement.__msh_origWord + '</b>"' + " " + txt2;
 	for (var i = select.length; --i >= 0;) {
 		select.remove(i);
@@ -339,13 +326,13 @@
 function displayInfo() {
 	var info = frame.contentWindow.spellcheck_info;
 	if (!info)
-		alert(i18n["No information available"]);
+		alert(dialog.plugin.localize("No information available"));
 	else {
-		var txt = i18n["Document information"] + "\n" ;
+		var txt = dialog.plugin.localize("Document information") + "\n" ;
 		for (var i in info) {
-			txt += "\n" + i18n[i] + " : " + info[i];
+			txt += "\n" + dialog.plugin.localize(i) + " : " + info[i];
 		}
-		txt += " " + i18n["seconds"];
+		txt += " " + dialog.plugin.localize("seconds");
 		alert(txt);
 	}
 	return false;
@@ -359,7 +346,7 @@
 	fixedWords = [];
 	suggested_words = frame.contentWindow.suggested_words;
 
-	document.getElementById("status").innerHTML = i18n["HTMLArea Spell Checker"]; 
+	document.getElementById("status").innerHTML = dialog.plugin.localize("HTMLArea Spell Checker");
 	var doc = frame.contentWindow.document;
 	var spans = doc.getElementsByTagName("span");
 	var sps = [];
@@ -391,10 +378,10 @@
 	wrongWords = sps;
 	if (sps.length == 0) {
 		if (!modified) {
-			alert(i18n["NO_ERRORS_CLOSING"]);
+			alert(dialog.plugin.localize("NO_ERRORS_CLOSING"));
 			window.close();
 		} else {
-			alert(i18n["NO_ERRORS"]);
+			alert(dialog.plugin.localize("NO_ERRORS"));
 		}
 		return false;
 	}
@@ -403,8 +390,8 @@
 	for (var i = as.length; --i >= 0;) {
 		var a = as[i];
 		a.onclick = function() {
-			if (confirm(i18n["CONFIRM_LINK_CLICK"] + ":\n" +
-				    this.href + "\n" + i18n["I will open it in a new page."])) {
+			if (confirm(dialog.plugin.localize("CONFIRM_LINK_CLICK") + ":\n" +
+				    this.href + "\n" + dialog.plugin.localize("I will open it in a new page."))) {
 				window.open(this.href);
 			}
 			return false;
@@ -435,3 +422,4 @@
 		select.selectedIndex = selectedOptionIndex;
 	}
 };
+
